BSDK.NET - BlomURBEX 3D Data Provider Software Development Kit

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Members

Public Member Functions
BSDKW::BModel Class Reference

Abstract class that is capable to receive a models tile from SDK. More...

List of all members.

## Public Types
Models attributes constants
enum | BLmodelattr { BL_MODEL_ATTR_BUILDING_BLOCK_ID_LIST = NatBModel.BLmodelattr.BL_MODEL_ATTR_BUILDING_BLOCK_ID_LIST, BL_MODEL_ATTR_BUILDING_BASE_POINT_LIST = NatBModel.BLmodelattr.BL_MODEL_ATTR_BUILDING_BASE_POINT_LIST, BL_MODEL_ATTR_SHARED_TEXTURES = NatBModel.BLmodelattr.BL_MODEL_ATTR_SHARED_TEXTURES }
| Models attributes identifiers. More...
## Public Member Functions
abstract void | Initialize (int meshesCount, int vertexCount, double[] vertexOffset)
| Start current models tile initialization.
abstract void | SetAttribute (NatBModel.BLmodelattr attributeName, bool[] value)
| Sets model attribute.
abstract void | SetAttribute (NatBModel.BLmodelattr attributeName, byte[] value)
abstract void | SetAttribute (NatBModel.BLmodelattr attributeName, int[] value)
abstract void | SetAttribute (NatBModel.BLmodelattr attributeName, double[] value)
abstract void | SetAttribute (NatBModel.BLmodelattr attributeName, string[] value)
abstract int[] | GetWritableVertexArray ()
| Requests client application to return the (X, Z, -Y) vertex array to write on it during initialization.
abstract void | ProcessVertexArray ()
| Lets client application process vertex array.
abstract int[] | GetWritableTexCoordsArray ()
| Requests client application to return the texture coordinates (X, Y) array to write on it during initialization.
abstract void | ProcessTexCoordsArray ()
| Lets client application process texture coordinates array.
abstract BMesh | GetWritableMesh ()
| Requests client application to return the indexth mesh to write on it during initialization.
abstract void | ProcessMesh ()
| Lets client application process the indexth mesh after SDK had writing on it.

## Detailed Description

Abstract class that is capable to receive a models tile from SDK.

See also:
  BShape, BMesh, BModel

## Member Enumeration Documentation

enum BSDKW::BModel::BLmodelattr

Models attributes identifiers.

See also:
  BSDK::BModel::SetAttribute

Enumerator:

  BL_MODEL_ATTR_BUILDING_BLOCK_ID_LIST |
  BL_MODEL_ATTR_BUILDING_BASE_POINT_LIST |
  BL_MODEL_ATTR_SHARED_TEXTURES |

## Member Function Documentation

abstract BMesh BSDKW::BModel::GetWritableMesh | ( |  | ) | `[pure virtual]`

Requests client application to return the indexth mesh to write on it during initialization.

See also:
  BMesh

abstract int [] BSDKW::BModel::GetWritableTexCoordsArray | ( |  | ) | `[pure virtual]`

Requests client application to return the texture coordinates (X, Y) array to write on it during initialization.

Returns:
  An integer array containing at least (2 * vertexCount) BLfixed32s

abstract int [] BSDKW::BModel::GetWritableVertexArray | ( |  | ) | `[pure virtual]`

Requests client application to return the (X, Z, -Y) vertex array to write on it during initialization.

In this array SDK will store vertexCount integers containing Spherical Mercator (X, Y) coordinates and Z in meters. Fixed value, 10 bits

Returns:
  An integer array containing at least (3 * vertexCount) BLfixed32s

abstract void BSDKW::BModel::Initialize | ( | int | meshesCount,
|  | int | vertexCount,
|  | double[] | vertexOffset
| ) |  | `[pure virtual]`

Start current models tile initialization.

It is expected that client application should allocate enough memory for meshCount BMeshes After this calling, this object will receive the following calls:

- BModel::SetAttribute() several times, to notify about all attributes.
- BModel::GetWritableVertexArray(), to configure vertexes array.
- BModel::GetWritableTexCoordsArray(), to configure texture coordinates array.
- BModel::GetWritableMesh() meshesCount times, to configure all the meshes.
  Returned memory should not be overriden or deleted until model tile loading task was finalized.
  Parameters:

    meshesCount | Meshes count
    vertexCount | Vertex count
    vertexOffset | Three components array containing an offset to apply to all tile 3D coordinates in (X, Z, -Y) format.

abstract void BSDKW::BModel::ProcessMesh | ( |  | ) | `[pure virtual]`

Lets client application process the indexth mesh after SDK had writing on it.

See also:
  BMesh

abstract void BSDKW::BModel::ProcessTexCoordsArray | ( |  | ) | `[pure virtual]`

Lets client application process texture coordinates array.

abstract void BSDKW::BModel::ProcessVertexArray | ( |  | ) | `[pure virtual]`

Lets client application process vertex array.

abstract void BSDKW::BModel::SetAttribute | ( | NatBModel.BLmodelattr | attributeName,
|  | double[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BModel::SetAttribute | ( | NatBModel.BLmodelattr | attributeName,
|  | string[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BModel::SetAttribute | ( | NatBModel.BLmodelattr | attributeName,
|  | int[] | value
| ) |  | `[pure virtual]`

abstract void BSDKW::BModel::SetAttribute | ( | NatBModel.BLmodelattr | attributeName,
|  | bool[] | value
| ) |  | `[pure virtual]`

Sets model attribute.

Client application implementation should be ready to receive unknown attribute names.

Parameters:

  attributeName | Attribute name
  value | Attribute values

See also:
  BModel::SetAttribute

abstract void BSDKW::BModel::SetAttribute | ( | NatBModel.BLmodelattr | attributeName,
|  | byte[] | value
| ) |  | `[pure virtual]`

The documentation for this class was generated from the following file:

- BSDK.cs

All Classes Namespaces Files Functions Variables Enumerations Properties Events